source('/home/Earth/aho/aho-testtest/startR/issue/issue115/CDORemap_issue115.R')
source('/home/Earth/aho/aho-testtest/startR/issue/issue115/CDORemapper_issue115.R')
source('/home/Earth/aho/aho-testtest/startR/issue/issue115/ArrayToNc_issue115.R')
source('/home/Earth/aho/aho-testtest/startR/issue/issue115/Start_issue115.R')

path <- '/esarchive/exp/ipsl-cm6a-lr/cmip6-dcppA-hindcast_i1p1/original_files/cmorfiles/DCPP/IPSL/IPSL-CM6A-LR/dcppA-hindcast/r1i1p1f1/SImon/siconc/gn/v20200101/$var$_SImon_IPSL-CM6A-LR_dcppA-hindcast_s2016-r1i1p1f1_gn_201701-202612.nc'
data <- Start(dat = path,
              var = 'siconc',
              x = 'all', #indices(2:361),
              y = 'all', #indices(2:331),
              time = indices(1), #'all',
#              transform = CDORemapper,
#              transform_extra_cells = 2,
#              transform_params = list(grid = 'r360x180',
#                                      method = 'bil',#'conservative',
#                                      crop = F),
##                                      crop = c(lon.min, lon.max, lat.min, lat.max)),
#              transform_vars = c('nav_lat', 'nav_lon'),
              return_vars = list(#x = NULL, y = NULL, 
                                 nav_lat = NULL, nav_lon = NULL),
              retrieve = TRUE)

lons <- attributes(data)$Variables$common$nav_lon#[2:361, 2:331]
lats <- attributes(data)$Variables$common$nav_lat#[2:361, 2:331]

res <- CDORemap(drop(data), lons, lats, grid = 'r100x50', method = 'bil', crop = FALSE)

#-------------------------------

data2 <- Start(dat = path,
              var = 'siconc',
              x = 'all', #indices(2:361),
              y = 'all', #indices(2:331),
              time = indices(1), #'all',
x_var = 'nav_lon',
y_var = 'nav_lat',
              transform = CDORemapper,
              transform_extra_cells = 2,
              transform_params = list(grid = 'r360x180',
                                      method = 'bil',#'conservative',
                                      crop = F),
#                                      crop = c(lon.min, lon.max, lat.min, lat.max)),
              transform_vars = c('nav_lon', 'nav_lat'),
              return_vars = list(#x = NULL, y = NULL, 
                                 nav_lon = NULL, nav_lat = NULL),
              retrieve = TRUE)



#----------------------------------

path3 <- '/esarchive/exp/ecearth/a1ua/cmorfiles/DCPP/EC-Earth-Consortium/EC-Earth3/dcppA-hindcast/r1i1p1f1/Omon/$var$/gn/v20190713/$var$_*_s$sdate$-$member$_gn_$aux$.nc'

data3 <- Start(dataset = path3,
               var = 'tos',
               sdate = paste0(1960),
               aux = indices(1),
               aux_depends = 'sdate',
               j = 'all',
#               j_var = 'latitude',
               i = 'all',
#               i_var = 'longitude',
               time = indices(1),
               member = 'r1i1p1f1',
               transform = CDORemapper,
               transform_extra_cells = 2,
               transform_params = list(grid = 'r360x180',
                                       method = 'bil',#'conservative',
                                       crop = F),
#                                       crop = c(lon.min, lon.max, lat.min, lat.max)),
               transform_vars = c('longitude', 'latitude'),
               return_vars = list(#j = NULL, i = NULL,
                                  latitude = NULL, longitude = NULL),
               retrieve = T)


