# When merge_across_dims = TRUE and split_multiselected_dims = TRUE, rearrange the chunks 
# (i.e., work_piece) is necessary if one file contains values for discrete dimensions
rebuild_array_merge_split <- function(data_array_tmp, indices_chunk, all_split_dims, 
                                      final_dims_fake, across_inner_dim, length_inner_across_dim) {
print('indices_chunk')
print(indices_chunk)
  # generate the correct order list from indices_chunk 
  final_order_list <- list()
  i <- 1
  j <- 1
  a <- indices_chunk[i]
  while (i <= length(indices_chunk)) {
    while (indices_chunk[i+1] == indices_chunk[i] & i < length(indices_chunk)) {
      a <- c(a, indices_chunk[i+1])
        i <- i + 1
    }
    final_order_list[[j]] <- a
    a <- indices_chunk[i+1]
    i <- i + 1
    j <- j + 1
  }
print('final_order_list 1')
print(str(final_order_list))
  names(final_order_list) <- sapply(final_order_list, '[[', 1)
  final_order_list <- lapply(final_order_list, length)
print('final_order_list 3')
print(str(final_order_list))

        
  if (!all(diff(as.numeric(names(final_order_list))) > 0)) {
    # shape the vector into the array without split_dims
    split_dims_pos <- match(all_split_dims[[1]], final_dims_fake)
    new_dims <- c()
    if (split_dims_pos[1] > 1) {
      new_dims <- c(new_dims, final_dims_fake[1:(split_dims_pos[1] - 1)])
    }
    new_dims <- c(new_dims,  prod(all_split_dims[[1]]))
    names(new_dims)[split_dims_pos[1]] <- across_inner_dim
    if (split_dims_pos[length(split_dims_pos)] < length(final_dims_fake)) {
      new_dims <- c(new_dims, final_dims_fake[(split_dims_pos[length(split_dims_pos)] + 1):length(final_dims_fake)])
    }
    data_array_no_split <- array(data_array_tmp, dim = new_dims)
    # seperate 'time' dim into each work_piece length
    data_array_seperate <- list()
    tmp <- cumsum(unlist(length_inner_across_dim))
    tmp <- c(0, tmp)
print('length_inner_across_dim')
print(length_inner_across_dim)
print('across_inner_dim')
print(across_inner_dim)
print('data_array_no_split')
print(dim(data_array_no_split))
print('tmp')
print(tmp)
    for (i in 1:length(length_inner_across_dim)) {
      data_array_seperate[[i]] <- Subset(data_array_no_split, across_inner_dim,
                                         (tmp[i] + 1):tmp[i + 1])
    }
print('data_array_seperate')
print(str(data_array_seperate))
    # re-build the array: chunk 
    which_chunk <- as.numeric(names(final_order_list))
print('which_chunk 1')
print(which_chunk)
#----------NEW-----------------
    sort_which_chunk <- sort(unique(which_chunk))
print('sort_which_chunk')
print(which_chunk2)
#    if (length(which_chunk2$x) != length(which_chunk)) {  # some values repeat
    which_chunk <- sapply(lapply(which_chunk, '==', sort_which_chunk), which)
#    } else 
print('which_chunk 2')
print(which_chunk)

#--------NEW_END---------------
    how_many_indices <- unlist(final_order_list)
    array_piece <- list()
    ind_in_array_seperate <- as.list(rep(1, length(data_array_seperate)))
    for (i in 1:length(final_order_list)) {
      array_piece[[i]] <- Subset(data_array_seperate[[which_chunk[i]]],
                                 across_inner_dim,
                                 ind_in_array_seperate[[which_chunk[i]]]:(ind_in_array_seperate[[which_chunk[i]]] + how_many_indices[i] - 1))
      ind_in_array_seperate[[which_chunk[i]]] <- ind_in_array_seperate[[which_chunk[i]]] + how_many_indices[i]
    }
   
    # re-build the array: paste
    data_array_tmp <- array_piece[[1]]
    along_pos <- which(names(dim(data_array_tmp)) == across_inner_dim)
    if (length(array_piece) > 1) {
      for (i in 2:length(array_piece)) {
        data_array_tmp <- abind::abind(data_array_tmp, array_piece[[i]],
                                       along = along_pos)
      }
    }
  }    
  
  return(data_array_tmp)
}

