
dates <- c(paste0(1961, '0', 1:5), paste0(1962, '0', 1:5))
dates_arr <- array(dates, dim = c(time = 5, syear = 2))

  obs <- Start(dat = '/esarchive/recon/jma/jra55/monthly_mean/$var$_f6h/$var$_$file_date$.nc',
               var = 'tas',
               file_date = dates_arr, # [syear, time]
#               time = dates,
#               time_across = 'file_date',
#               merge_across_dims = TRUE,
               split_multiselected_dims = TRUE,
               latitude = indices(1),
               longitude = indices(1),
               synonims = list(latitude = c('lat','latitude'),
                               longitude = c('lon','longitude')),
               return_vars = list(latitude = NULL, longitude = NULL,
                                  time = 'file_date'),
               retrieve = TRUE)

dim(obs)
#      dat       var      time     syear  latitude longitude 
#        1         1         5         2         1         1 

dim(attr(obs, 'Variables')$common$time)
# time  time syear  time  time 
#    5     1     2     5     1 
##Should be [time = 5, syear = 2]
