library(easyNCDF)
file <- NcOpen('/esarchive/recon/ecmwf/era5/monthly_mean/tas_f1h-r360x180/tas_198101.nc')
# To load the full data (full dimensions)
obs2 <- NcToArray(file, vars_to_read = 'tas')
# To load subset data
obs2 <- NcToArray(file, vars_to_read = 'tas',
                  dim_indices = list(lon = c(1:10),
                                     lat = c(1:10),
                                     time = c(1)))
lats2 <- NcToArray(file, vars_to_read = 'lat',
                   dim_indices = list(lat = 1:10)) 
lons2 <- NcToArray(file, vars_to_read = 'lon',
                   dim_indices = list(lon = 1:10)) 
NcClose(file)

