run_unittest <- function(package_path = '/home/Earth/aho/startR/', start = 1, load_package = FALSE) {

library(testthat)
if (load_package) {
  library(tail(strsplit(package_path, '/')[[1]], 1), character.only = T)
}

path_testthat <- file.path(package_path, "tests/testthat/") #'/home/Earth/aho/startR/tests/testthat/'
files_testthat <- list.files(path_testthat)

for (iii in start:length(files_testthat)) {
  full_path <- paste0(path_testthat, files_testthat[iii])
  print(paste0('Start running file ', iii, ': ', files_testthat[iii], '......'))
  source(full_path)
  print(paste0("File ", iii, ": ", files_testthat[iii], ' finished!'))
}

return("ALL THE UNIT TESTS ARE PASSED.")

}
