
# $var$ is not used
hcst.path <- "/esarchive/exp/ecmwf/system5c3s/monthly_mean/tas_f6h/tas_$syear$.nc"
hcst.path <- "/esarchive/exp/ecmwf/system5c3s/monthly_mean/$var$_f6h/$var$_$syear$.nc"

variable <- "tas"
hcst.sdates <- paste0(1993:2016,"0501")
dim(hcst.sdates) <- list(syear=length(hcst.sdates))
longitude_reorder = CircularSort(0, 361)
latitude_reorder = Sort(decreasing=TRUE)

data <- Start(dat = hcst.path,
              var = variable,
              syear = hcst.sdates,
              time = indices(1:6),
              latitude = values(list(-40, 10)),
              latitude_reorder = latitude_reorder,
              longitude = values(list(0, 60)),
              longitude_reorder = longitude_reorder,
              synonims = list(latitude=c('lat','latitude'),
                              longitude=c('lon','longitude'),
                              member=c('ensemble')), 
              member = indices(1:25),
              return_vars = list(latitude = 'dat',
                                 longitude = 'dat',
                                 time = c('syear')),
              split_multiselected_dims = FALSE,
              retrieve = T)
